<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2014 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: youtube_bbcode_include.php
| Author: Wooya
| Modified by: Pisatel ( http://www.meweb.ru )
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
    if (!defined("IN_FUSION")) { die("Access Denied"); }
    unset($matches);
    preg_match_all("#\[youtube\](.*?)\[\/youtube\]#si", $text, $matches, PREG_PATTERN_ORDER);
    if (count($matches[0])>0){
    add_to_head("<link rel='stylesheet' href='".INCLUDES."jquery/colorbox/colorbox.css' type='text/css' media='screen' />
<script type='text/javascript' src='".INCLUDES."jquery/colorbox/jquery.colorbox.js'></script>
<script type='text/javascript'>
    $(document).ready(function(){
     $('.youtube').colorbox({
     iframe:true,
     innerWidth:640,
     innerHeight:390
     });
 });
</script>\n");

    if (!function_exists('getWord')){
    function getWord($number, $suffix){
    $keys = array(2, 0, 1, 1, 1, 2);
    $modern = $number % 100;
    $suffix_key = ($modern > 7 && $modern < 20) ? 2 : $keys[min($modern % 10, 5)];
    return $suffix[$suffix_key];
   }
}
    for($i=0; $i<count($matches[0]); $i++) {
    $vurl = preg_replace("/http(s)*:\/\/(www\.)*youtube\.com\/watch\?v=/si", "", trim($matches[1][$i]));
    $api = 'http://gdata.youtube.com/feeds/api/videos/'.$vurl.'?v=2';
    $headers = get_headers($api);
    $youtube = strpos($headers[0], '200') ? simplexml_load_file($api) : '';
    if (!empty($youtube)){
    $media = $youtube->children('http://search.yahoo.com/mrss/');
    $yt = $youtube->children('http://gdata.youtube.com/schemas/2007');
    $attrs = $yt->statistics->attributes();
    $viewCount = $attrs['viewCount'];
    $yt = $media->children('http://gdata.youtube.com/schemas/2007');
    $attrs = $yt->duration->attributes();
    $length_min = floor($attrs['seconds'] / 60);
    $length_sec = $attrs['seconds'] % 60;
    $min = getWord($length_min, $locale['arraymin']);
    $sec = getWord($length_sec, $locale['arraysec']);
    $attrs = $media->group->thumbnail[0]->attributes();
    $thumb = $attrs['url'];
    $gd = $youtube->children('http://schemas.google.com/g/2005');
    if ($gd->rating){
    $attrs = $gd->rating->attributes();
    $rating = $attrs['average'];
    $numRaters = $attrs['numRaters'];
} else {
    $rating = 0;
    $numRaters = 0;
}
    $golos = getWord($numRaters, $locale['arraygolos']);
    $yt1 = $youtube->children('http://gdata.youtube.com/schemas/2007');
    if($yt1->rating && $yt1->rating[0]->attributes()){
    $attrs1 = $yt1->rating[0]->attributes();
    $dislikes = strval($attrs1['numDislikes']);
    $likes = strval($attrs1['numLikes']);
} else {
    $dislikes = 0;
    $likes = 0;
}
    $title = iconv("UTF-8", "WINDOWS-1251", trim(stripinput((string)$youtube->title)));
    $author = iconv("UTF-8", "WINDOWS-1251", trim(stripinput((string)$youtube->author->name)));
    $published = showdate("longdate", strtotime( $youtube->published));
    $vinfo = '<strong>'.$locale['zagolovok'].'</strong>'.$title.'<br />';
   $vinfo .= '<strong>'.$locale['avtor'].'</strong>'.$author.$locale['v200'].$published.'<br />';
    $vinfo .= '<strong>'.$locale['prosmotrov'].'</strong>'.number_format($viewCount,0, '.', ' ').'<br />';
    $vinfo .= '<strong>'.$locale['prod'].'</strong>'.$length_min.$min.$length_sec.$sec.'<br />';
    $vinfo .= '<strong>'.$locale['rayting'].'</strong>'.number_format($rating, 2, ',', ' ').' ('.$numRaters.$golos.')  <span style="color:#006400;">'.$likes.'</span> / <span style="color:#ee0000;">'.$dislikes.'</span>';
    $vimg = '<a class="youtube" href="http://www.youtube.com/embed/'.$vurl.'?rel=0&amp;wmode=transparent" title="'.$locale['bb_youtube'].$title.'"><img src="'.$thumb.'" alt="'.$locale['bb_youtube'].$title.'" title="'.$locale['bb_youtube'].$title.'" style="border:0;" class="tbl" /></a>';
} else {
    $vinfo = '<strong>'.$locale['nodata'].'</strong>';
    $title = $locale['nodata'];
    $vimg = '<img src="http://www.youtube.com/yt/brand/media/image/yt-brand-strike-1.png" alt="'.$locale['bb_youtube'].$title.'" style="border:0;" />';
}
    $text = preg_replace('#\[youtube\](.*?)\[\/youtube\]#si', '<strong>'.$locale['bb_youtube'].'</strong><div style="margin:3px; display:table;">'.$vimg.'<div style="display:table-cell; padding-left:20px; vertical-align:top;">'.$vinfo.'</div></div>', $text, 1);
   }
}
?>